Rem
##########################################################
#	Projekt: 				Knorks			#
#	Autor:				Stephan Kessler		#
#	Erstellungsdatum:			19.02.2010			#	
#	Version:				0.8				#
##########################################################
End Rem



'//---Grundeimstellungen--//
	SetGraphicsDriver GLMax2DDriver()
	Graphics 800,600,0,70
	SetAlpha 1
	SetBlend(ALPHABLEND)
	AutoMidHandle(1)
	SeedRnd MilliSecs()									'Random-Referenz Generieren
	seed=RndSeed()										'Random-Referenz Generieren
	timer=CreateTimer(60)
	HideMouse()
	font=LoadImageFont("c:\windows\fonts\verdana.ttf",20,style=SMOOTHFONT)
	SetImageFont(font)

'//-----------//


'//---Variablen--//
	Global maxk=40
	Global knorks[maxk+1,31]
'			  |	|
'			  |	|-----Subinfo
'			  |
'			  |---------knorks_ID	
	Rem
	Subinfo 
	
	0	=	Geschlecht
	1	=	x
	2	=	y
	3	=	Bewegungsbild links
	4	=	Bewegungsbild rechts
	5	=	Schlafbild
	6	=	Sexbild
	7	=	Stirbbild
	8	=	Fallbild
	9	=	Essbild
	10	=	Babybild links
	11	=	Babybild rechts
	
	20	=	Essen
	21	=	Schlafen
	22	=	Sexstand
	23	= 	Sterben
	24	=	PennPos
	25	=	Partnerfound
	26	= 	PartnerPos
	27	=	PartnerID
	28	= 	Babyzeit
	
	30	=	Status	
	End Rem	
	
	Rem
	Status
	
	End Rem	
	
	Global a
	Global b	
	Global essen_aktiv
	Global sex_aktiv
	Global frucht[5,4] '0=bild, 1=x, 2=y, 3=aktiv
	Global live=1
	Global fressf
	Global sexf
'//-----------//


'//---Laden--//
	Global img_menue=LoadImage("img\menue.png")
	Global img_modus1=LoadImage("img\normalmodus.png")
	Global img_modus2=LoadImage("img\rindermodus.png")
	Global img_modus3=LoadImage("img\karnickelmodus.png")
	Global img_exit=LoadImage("img\exit.png")
	Global img_maus=LoadImage("img\maus.png")

	Global img_world=LoadImage("img\world1.png")
	Global img_black=LoadImage("img\black.png")
	Global img_baum=LoadImage("img\baum.png")
	Global img_strahl=LoadImage("img\strahl.png")
	
	Global snd_jungle=LoadSound("snd\jungleam-boy-8745.wav",1)
	Global snd_vacuuming=LoadSound("snd\vacuuming.wav")
	Global snd_duck=LoadSound("snd\duck.wav")
	Global snd_baby=LoadSound("snd\baby.wav")
	Global snd_pupertat=LoadSound("snd\pupertat.wav")
	
	Global channel=AllocChannel()
	Global channel_vacuuming=AllocChannel()
	Global channel_duck=AllocChannel()
	Global channel_baby=AllocChannel()
	Global channel_pupertat=AllocChannel()
	
	SetChannelVolume(channel,.5)
	SetChannelVolume(channel_vacuuming,.3)
	
	For a=0 To 4
		frucht[a,0]=LoadImage("img\frucht.png")
		frucht[a,1]=Rand(75,120)
		frucht[a,2]=135
	Next
'//-----------//



'//---Men--//
	user_anzahl=1
	While 1
		DrawImage img_menue,400,300
		DrawImage img_modus1,150,330
		DrawImage img_modus2,400,330
		DrawImage img_modus3,650,330
		DrawImage img_exit,50,570
		DrawImage img_maus,MouseX(),MouseY()
		If MouseHit(1) =1 Then klick = 1
		If ImagesCollide(img_maus,MouseX(),MouseY(),0,img_modus1,100,350,0)
			DrawText "Normalmodus: Die Knorks werden sich ganz normal verhalten.",90,460
			fressf=1
			sexf=1
			If klick Then Exit
		EndIf
		If ImagesCollide(img_maus,MouseX(),MouseY(),0,img_modus2,400,330,0)
			DrawText "Rindermodus: Die Knorks haben Fressen als Tagesbeschftigung.",90,460
			fressf=2
			sexf=1
			If klick Then Exit
		EndIf
		If ImagesCollide(img_maus,MouseX(),MouseY(),0,img_modus3,650,330,0)
			DrawText "Karnickelmodus: Alle Knorks denken nur an das Eine.",90,460
			fressf=1
			sexf=4
			If klick Then Exit
		EndIf
		If ImagesCollide(img_maus,MouseX(),MouseY(),0,img_exit,50,570,0)
			DrawText "Tschss!",90,460
			If klick Then End
		EndIf
		Flip
		WaitTimer timer
		If KeyHit(KEY_ESCAPE) Then End
		klick = 0
	Wend 
'//-----------//



'//---Spiel--//
	If user_anzahl = 1									'Generiert 2 knorks
		knorks[0,0]=0									'First-Male
		knorks[1,0]=1									'First-Female
		knorks[0,30] = 0
		knorks[1,30] = 0
		For a=0 To maxk
			knorks[a,1] = Rand(100,700)
			knorks[a,2] = -100	
			If a>1 Then	 knorks[a,0] = Rand(0,1)				'den Restlichen ein Geschlecht geben
			
			If knorks[a,0]=0								'Males laden
				knorks[a,3]=LoadImage("img\k-m-3.png")
				knorks[a,4]=LoadImage("img\k-m-4.png")				
				knorks[a,5]=LoadImage("img\sleep-m.png")				
				knorks[a,6]=LoadImage("img\sex.png")	
				knorks[a,7]=LoadImage("img\dead.png")
				knorks[a,8]=LoadImage("img\fall-m.png")	
				knorks[a,9]=LoadImage("img\e-m-3.png")	
				knorks[a,10]=LoadImage("img\k-m-1.png")	
				knorks[a,11]=LoadImage("img\k-m-2.png")	
			EndIf
			If knorks[a,0]=1								'Females laden
				knorks[a,3]=LoadImage("img\k-w-3.png")
				knorks[a,4]=LoadImage("img\k-w-4.png")				
				knorks[a,5]=LoadImage("img\sleep-w.png")				
				knorks[a,6]=LoadImage("img\null.png")	
				knorks[a,7]=LoadImage("img\dead.png")	
				knorks[a,8]=LoadImage("img\fall-w.png")	
				knorks[a,9]=LoadImage("img\e-w-3.png")
				knorks[a,10]=LoadImage("img\k-w-1.png")	
				knorks[a,11]=LoadImage("img\k-w-2.png")	
			EndIf
			
			knorks[a,20] = Rand(3000,5000)					'Hunger (4000,10000)
			knorks[a,21] = Rand(7000,10000)					'Schlaf
			knorks[a,22] = Rand(7000,9000)					'Sex		
			knorks[a,23] = 200
			knorks[a,24] = Rand(450,750)						'Schlafposi
			knorks[a,28] = Rand(15000,18000)					'Schlafposi
			
			
			If a>1 Then knorks[a,30] = 7
		Next				
	EndIf

	PlaySound snd_jungle,channel

	While Not KeyHit(KEY_ESCAPE)
		DrawImage img_black,400,300
		DrawImage img_world,400,300			
		For a=0 To live
			Select knorks[a,30]
				Case 0 fallen(a)
				Case 1 laufl(a)
				Case 2 laufr(a)
				Case 3 essen(a)
				Case 4 sterben(a)
				Case 5 schlafen(a)
				Case 6 sex(a)
				Case 7 geburt(a)
				Case 8 blaufl(a)
				Case 9 blaufr(a)	
				Case 10 pupertat(a)		
			End Select
		Next
		DrawImage img_baum,400,300
		Flip 0
		WaitTimer timer
		'Print knorks[0,20]
	Wend End
'//-----------//



'//---Funktionen--//
	Function fallen(a)
		DrawImage knorks[a,8],knorks[a,1],knorks[a,2]
		DrawImage img_strahl,knorks[a,1],300
		knorks[a,2]=knorks[a,2]+4
		If knorks[a,2]>520 Then knorks[a,30] = Rand(1,2)
	End Function
	
	Function laufl(a)
		DrawImage knorks[a,3],knorks[a,1],knorks[a,2]
		knorks[a,1]=knorks[a,1]-1
		If knorks[a,1]<100 Then knorks[a,30]=2
		If Rand(0,1000) > 998 Then knorks[a,30]=2
		knorks[a,20] = knorks[a,20]-1*fressf
		knorks[a,21] = knorks[a,21]-2
		If knorks[a,22] > 400 Then knorks[a,22] = knorks[a,22]-2*sexf
		If knorks[a,20] < 2000 And essen_aktiv = 0 Then knorks[a,30]=3	'Hunger abfragen
		If knorks[a,21] < 2000 Then knorks[a,30]=5				'Schlaf abfragen	
		If knorks[a,22] < 500 Then sex(a)						'Sex abfragen	
		If knorks[a,20] < 0 Then knorks[a,30]=4 
		If knorks[a,21] < 0 Then knorks[a,30]=4		
	End Function

	Function laufr(a)
		DrawImage knorks[a,4],knorks[a,1],knorks[a,2]
		knorks[a,1]=knorks[a,1]+1
		If knorks[a,1]>750 Then knorks[a,30]=1
		If Rand(0,1000) > 998 Then knorks[a,30]=1
		knorks[a,20] = knorks[a,20]-1*fressf
		knorks[a,21] = knorks[a,21]-2
		If knorks[a,22] > 400 Then knorks[a,22] = knorks[a,22]-2*sexf
		If knorks[a,20] < 2000 And essen_aktiv = 0 Then knorks[a,30]=3	'Hunger abfragen
		If knorks[a,21] < 2000 Then knorks[a,30]=5				'Schlaf abfragen
		If knorks[a,22] < 500 Then sex(a)						'Sex abfragen	
		If knorks[a,20] < 0 Then knorks[a,30]=4 
		If knorks[a,21] < 0 Then knorks[a,30]=4 	
	End Function
	
	Function blaufl(a)	'Babylaufen Links
		DrawImage knorks[a,10],knorks[a,1],knorks[a,2]
		knorks[a,1]=knorks[a,1]-1
		If knorks[a,1]<100 Then knorks[a,30]=9
		If Rand(0,1000) > 998 Then knorks[a,30]=9
		knorks[a,28] = knorks[a,28]-2
		If knorks[a,28] < 500 Then knorks[a,30]=10
	End Function

	Function blaufr(a)	'Babylaufen Rechts
		DrawImage knorks[a,11],knorks[a,1],knorks[a,2]
		knorks[a,1]=knorks[a,1]+1
		If knorks[a,1]>750 Then knorks[a,30]=8
		If Rand(0,1000) > 998 Then knorks[a,30]=8
		knorks[a,28] = knorks[a,28]-2
		If knorks[a,28] < 500 Then knorks[a,30]=10	
	End Function
	
	Function essen(a)
		If essen_aktiv=2 And knorks[a,1]>120  Then knorks[a,30]=1 	'Essen-Bug beheben (Wenn schon jemand isst -> essen abbrechen)
		If essen_aktiv=1 And knorks[a,1]<120 
			PlaySound(snd_vacuuming,channel_vacuuming)
			essen_aktiv=2
		EndIf
		If essen_aktiv=0 Then essen_aktiv=1
		If knorks[a,1]>100
			DrawImage knorks[a,3],knorks[a,1],knorks[a,2]
			knorks[a,1]=knorks[a,1]-1
		EndIf
		If knorks[a,1]<=100 And knorks[a,20] < 9990
			knorks[a,20] = knorks[a,20]+5
			futterfall(a)
			DrawImage knorks[a,9],knorks[a,1],knorks[a,2]
		EndIf
		If knorks[a,20] => 9990
			knorks[a,30]=1
			StopChannel channel_vacuuming
			essen_aktiv=0
		End If		
	End Function	
	
	Function sterben(a)
		If knorks[a,23] > 0 Then DrawImage knorks[a,7],knorks[a,1],knorks[a,2]
		If knorks[a,23] = 0 knorks[a,30]=100
		knorks[a,23]=knorks[a,23]-1	
	End Function
	
	Function futterfall(a)
		For b=0 To 4
			If Rand(0,1000) > 990 And frucht[b,3] = 0 And knorks[a,20] < 9500 Then frucht[b,3] = 1
			If frucht[b,3] = 1 
				DrawImage frucht[b,0], frucht[b,1], frucht[b,2]
				frucht[b,2]=frucht[b,2]+8
				If frucht[b,2] > 530 
					frucht[b,3] = 0
					frucht[b,1]=Rand(75,120)
					frucht[b,2]=135				
				EndIf
			EndIf
		Next
	End Function
	
	Function schlafen(a)
		If knorks[a,1]<knorks[a,24]
			DrawImage knorks[a,4],knorks[a,1],knorks[a,2]
			knorks[a,1]=knorks[a,1]+1
		EndIf
		If knorks[a,1]>=knorks[a,24] And knorks[a,21] < 9990
			knorks[a,21] = knorks[a,21]+4
			DrawImage knorks[a,5],knorks[a,1],knorks[a,2]
		EndIf
		If knorks[a,21] => 9990
			knorks[a,30]=2
		End If		
	End Function
	
	Function sex(a)
		If knorks[a,0]=0 And knorks[a,25]=0					'ER sucht SIE
			For b=0 To live
				If knorks[b,0] = 1				 		'nicht Schwul ;)
					If knorks[b,22] < 500 And knorks[b,25] = 0 
						If knorks[b,30] = 3 Or knorks[b,30] = 4 Or knorks[b,30] = 5  
						Else 	'Sie nicht am schlafen, essen oder sterben ;)
							knorks[a,25]=1 					'Er Partner gefunden		
							knorks[b,25]=1					'Sie Partner gefunden
							knorks[a,26]=knorks[b,1]
							knorks[a,30]=6
							knorks[b,30]=6
							knorks[a,27]=b
							knorks[b,27]=a
							sex_aktiv=1
						EndIf
					EndIf
				End If
			Next
		EndIf

		If knorks[a,0]=0 And knorks[a,25]=1 											'Er geht zu ihr
			If knorks[a,1] > knorks[a,26]
				DrawImage knorks[a,3],knorks[a,1],knorks[a,2]
				knorks[a,1]=knorks[a,1]-1
			EndIf
			If knorks[a,1] < knorks[a,26]
				DrawImage knorks[a,4],knorks[a,1],knorks[a,2]
				knorks[a,1]=knorks[a,1]+1
			EndIf
		EndIf
		If knorks[a,1] - knorks[a,26] > -5 And  knorks[a,1] - knorks[a,26] < 5 And knorks[a,0]=0		'Sex sobald in der nhe
			DrawImage knorks[a,6],knorks[a,1],knorks[a,2]
			knorks[knorks[a,27],22]=knorks[knorks[a,27],22]+10
			knorks[a,22]=knorks[a,22]+20
			If sex_aktiv = 1 Then PlaySound(snd_duck,channel_duck)
			sex_aktiv = 0
		Else
			If knorks[a,0]=0 And knorks[a,25]=1 Then  DrawImage knorks[knorks[a,27],3],knorks[knorks[a,27],1],knorks[knorks[a,27],2]
		EndIf
		If knorks[a,22] > 12000 
			knorks[a,30] = 1
			knorks[knorks[a,27],30] = 2
			knorks[a,25]=0									
			knorks[knorks[a,27],25]=0					
			knorks[a,26]=0
			knorks[a,27]=0
			knorks[knorks[a,27],27]=0
			liveup(a)
		EndIf		
	End Function

	Function liveup(a)
		If live < maxk Then 
			live=live+1	
			knorks[live,2] = knorks[a,2] + 23
			knorks[live,1] = knorks[a,1] 
		Else
			For b=0 To maxk
			 	If knorks[b,30] = 100
					Exit						'Schleife beenden
				EndIf
			Next
			knorks[b,20] = Rand(4000,10000)					'Hunger
			knorks[b,21] = Rand(7000,10000)					'Schlaf
			knorks[b,22] = Rand(1500,3000)					'Sex		
			knorks[b,23] = 200
			knorks[b,24] = Rand(550,700)						'Schlafposi
			knorks[b,28] = Rand(15000,18000)					'Schlafposi			
			knorks[b,2] = knorks[a,2] + 23
			knorks[b,1] = knorks[a,1]
		EndIf			
	End Function

	Function geburt(a)
		knorks[a,30] = Rand(8,9)
		PlaySound(snd_baby,channel_baby)	
	End Function
	
	Function pupertat(a)
		knorks[a,30] = Rand(1,2)
		knorks[a,2]=knorks[a,2] - 23	
		PlaySound(snd_pupertat,channel_pupertat)
	End Function
'//-----------//
