Graphics 800,600,32,2
SetBuffer BackBuffer()

Local game_timer = CreateTimer(80)

Global Gw = GraphicsWidth()
Global Gh = GraphicsHeight()
Global TileSize = 16
Global MapX = Gw/TileSize
Global MapY = Gh/TileSize
Global Mx,My,Timer = MilliSecs(),Play=0
Dim Map(MapX,MapY)
Dim TMap(MapX,MapY)

Dim DieRule(9)
Dim LifeRule(9)
LifeRule(3)=1
DieRule(0)=1
DieRule(1)=1
DieRule(4)=1
DieRule(5)=1
DieRule(6)=1
DieRule(7)=1
DieRule(8)=1


While Not KeyDown(1)
	WaitTimer(game_timer)
	Mx = MouseX()/TileSize:My = MouseY()/TileSize
	If MouseDown(1) Then Map(Mx,My)=1
	If MouseDown(2) Then Map(Mx,My)=0
	If KeyHit(28) Then NextGen()
	If KeyHit(57) Then Play = 1-Play
	
	If Play Then
		If Timer < MilliSecs()
			NextGen()
			Timer = MilliSecs()+100
		End If
	End If
	DrawMap()
	Color 0,255,0
	Oval 0,0,20,20,Play
	Color 255,255,255
	Flip 0
	Cls
Wend
End

Function DrawMap()
	Local x,y
	For x = 0 To MapX-1
		For y = 0 To MapY-1
			If Map(x,y) = 1 Then Oval x*TileSize,y*TileSize,TileSize,TileSize
		Next
	Next
End Function

Function NextGen()
	Local x,y,z,d,c
	CopyMap()
	For x = 0 To MapX-1
		For y = 0 To MapY-1
			For z = 0 To 8
				d = TMap(x,y)
				c = CountN(x,y)
				Select d
					Case 0
						If LifeRule(z)=1 And c=z Then Map(x,y)=1
					Case 1
						If DieRule(z)=1 And c=z Then Map(x,y)=0
				End Select
			Next
		Next
	Next
End Function

Function CountN(x,y)
	Local count
	count=count+TMap(x+1,y)
	count=count+TMap(x-1,y)
	count=count+TMap(x,y+1)
	count=count+TMap(x,y-1)
	count=count+TMap(x+1,y+1)
	count=count+TMap(x-1,y-1)
	count=count+TMap(x-1,y+1)
	count=count+TMap(x+1,y-1)
	Return count
End Function

Function CopyMap()
	Local x,y
	For x = 0 To MapX-1
		For y = 0 To MapY-1
			TMap(x,y)=Map(x,y)
		Next
	Next
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D