Global xxx,yyy
Global rule$

Dim feld(50,50)
Dim feldx(50,50)
Global mx,my,timer
Global survive$,entst$
Global rimg,rimg2,rimg3

SeedRnd MilliSecs()

Graphics 640,480,16,2

SetBuffer BackBuffer()
ClsColor 255,255,255
Cls

Color 0,0,0
dgang = 1
Repeat
  If dgang <> 1 Then
    Graphics 640,480,16,2
    ClsColor 255,255,255
    Cls
    Color 0,0,0
    Print "Zum Beenden bitte 'b' eingeben, sonst etwas anderes."
    If Input() = "b" Then End
  EndIf
  Repeat
    Print "Bitte Breite eingeben (in Feldern, ein Feld = 20px, bis zu 50):"
    xxx = Int(Input())
  Until xxx < 51 And xxx > 0
  Repeat
    Print "Bitte Hhe eingeben (in Feldern, ein Feld = 20px, bis zu 50):"
    yyy = Int(Input())
  Until yyy < 51 And yyy > 0
  Print "Bitte Regel eingeben:"
  Print "Wie verschiedene Regeln bei Conway's Spiel des Lebens funktionieren,"
  Print "erfhrst du auf dem Wikipediaartikel zum Thema oder in der Readme."
  Print "Conways ursprngliche Regel war 23/3"
  rule$ = Input()
  Repeat
    Print "Geschwindigkeit der Simulation (in FPS, Empfehlung: 10)"
    fps = Int(Input())
  Until fps > 0

  EndGraphics()
  Graphics xxx*20,yyy*20,16,2

  rimg = CreateImage(20,20)
  SetBuffer ImageBuffer(rimg)
  Color 0,0,0
  Rect 0,0,20,20
  MaskImage rimg,255,255,255

  rimg2 = CreateImage(20,20)
  SetBuffer ImageBuffer(rimg2)
  Color 0,255,0
  Rect 0,0,20,20
  Color 0,0,0
  Line 0,0,0,20
  MaskImage rimg2,255,255,255

  rimg3 = CreateImage(20,20)
  SetBuffer ImageBuffer(rimg3)
  Color 0,0,255
  Rect 0,0,20,20
  Color 0,0,0
  Line 0,0,0,20
  MaskImage rimg3,255,255,255

  SetBuffer BackBuffer()
  ClsColor 255,255,255
  Cls
  timer = CreateTimer(fps)
  Dim_empty()
  Init_Rule()
  play()
  dgang = dgang + 1
  FreeTimer timer
  EndGraphics()
Forever


Function play()
  Color 0,0,0
  Repeat
    Cls
    mx = MouseX() : my = MouseY()
    For x = 0 To xxx
      Line x*20-1,0,x*20-1,yyy*20
      Line x*20,0,x*20,yyy*20
      For y = 0 To yyy
        Line 0,y*20-1,xxx*20,y*20-1
        Line 0,y*20,xxx*20,y*20
        If feld(x,y) = 1 Then
          DrawImage rimg,x*20,y*20
        ElseIf feld(x,y) = 2 Then
          DrawImage rimg2,x*20,y*20
        ElseIf feld(x,y) = 3 Then
          DrawImage rimg3,x*20,y*20
        EndIf
        If menucheck(x*20,y*20,20,20) = 1 Then
          If MouseHit(1) Then feld(x,y)=1-feld(x,y) : If feld(x,y) = -1 Or feld(x,y) = -2 Then feld(x,y) = 0
          If MouseHit(2) Then
            Select feld(x,y)
              Case 0,1
                feld(x,y)=2
              Case 2
                feld(x,y)=3
              Case 3
                feld(x,y)=2
            End Select
          EndIf
        EndIf
      Next
    Next
    Flip 0
    If KeyHit(1) Then Return 1
  Until KeyDown(28)
  FlushKeys

  For y = 0 To yyy
    For x = 0 To xxx
      If feld(x,y) = 2 Then feld(x,y) = Rand(0,1)
      feldx(x,y) = feld(x,y)
    Next
  Next

  gene = 1
  Repeat
    For x = 0 To xxx
      For y = 0 To yyy
        cv = (1-feld(x,y))*255
        Color cv,cv,cv
        If feld(x,y) = 3 Then Color 0,0,255
        Rect x*20,y*20,20,20
      Next
    Next
    Color 0,0,0
    Text 0,0,gene
    Flip
    Generation()
    WaitTimer timer
    gene = gene + 1
  Until KeyDown(1)
End Function

Function Generation()
  For x = 0 To xxx
    For y = 0 To yyy
      nachb = Get(x-1,y-1) + Get(x,y-1) + Get(x+1,y-1) + Get(x-1,y) + Get(x+1,y) + Get(x-1,y+1) + Get(x,y+1) + Get(x+1,y+1)
      If feld(x,y) = 0 Then If Rule_OK(nachb,entst$) = 1 Then feldx(x,y) = 1
      If feld(x,y) = 1 Then If Rule_OK(nachb,survive$) <> 1 Then feldx(x,y) = 0
    Next
  Next
  For x = 0 To xxx
    For y = 0 To yyy
      feld(x,y) = feldx(x,y)
    Next
  Next
End Function

Function Get(nrx,nry)
  If nrx => 0 And nrx <= xxx And nry => 0 And nry <= yyy Then
    ret = feld(nrx,nry)
    If feld(nrx,nry) = 3 Then ret = 0
  Else
    ret = 0
  EndIf
  Return ret
End Function

Function menucheck(a,b,c,d)
  If mx > a And mx < a+c Then
    If my > b And my < b+d Then
      Return 1
    Else
      Return 0
    EndIf
  Else
    Return 0
  EndIf
End Function

Function Init_Rule()
  rp = Instr(rule$, "/")
  survive$ = Left$(rule$, rp-1)
  entst$ = Right$(rule$,Len(rule$)-rp)
End Function

Function Rule_OK(nz,rule_part$)
  For i = 1 To Len(rule_part$)
    If Int(Mid(rule_part$,i,1)) = nz Then Return 1
  Next
  Return 0
End Function

Function Dim_empty()
  For y = 0 To yyy
    For x = 0 To xxx
      feld(x,y)  = 0
      feldx(x,y) = 0
    Next
  Next
End Function